<script lang="ts">
import { defineProps } from 'vue';

export default {
  name: 'JAvatar',
};
</script>

<script setup lang="ts">
defineProps({
  size: {
    type: String,
    default: 'xs',
    validator(value: string): boolean {
      return ['xs', 's', 'm', 'xxl', 'xl-3', 'full'].includes(value);
    },
  },
  rounded: {
    type: String,
    default: 'full',
  },
});
</script>

<template>
  <div
    class="j-avatar"
    :class="[size, `rounded-${rounded}`]"
  >
    <div
      class="avatar-content"
      :class="[`rounded-${rounded}`]"
    >
      <slot />
    </div>
    <div
      v-if="$slots.status"
      class="j-avatar-status"
      :class="[size]"
    >
      <slot name="status" />
    </div>
  </div>
</template>

<style lang="scss" scoped>
@import './variables.scss';

.j-avatar {
  display: flex;
  justify-content: center;
  align-items: center;
  position: relative;

  .avatar-content {
    display: flex;
    flex-shrink: 0;
    justify-content: center;
    align-items: center;
    overflow: hidden;
  }

  &.xs {
    width: map-get($j-avatar-size, wrapper, xs, width);
    height: map-get($j-avatar-size, wrapper, xs, height);

    .avatar-content {
      width: map-get($j-avatar-size, avatar, xs, width);
      height: map-get($j-avatar-size, avatar, xs, height);
    }
  }

  &.s {
    width: map-get($j-avatar-size, wrapper, s, width);
    height: map-get($j-avatar-size, wrapper, s, height);

    .avatar-content {
      width: map-get($j-avatar-size, avatar, s, width);
      height: map-get($j-avatar-size, avatar, s, height);
    }
  }

  &.m {
    width: map-get($j-avatar-size, wrapper, m, width);
    height: map-get($j-avatar-size, wrapper, m, height);

    .avatar-content {
      width: map-get($j-avatar-size, avatar, m, width);
      height: map-get($j-avatar-size, avatar, m, height);
    }
  }

  &.xxl {
    width: map-get($j-avatar-size, wrapper, xxl, width);
    height: map-get($j-avatar-size, wrapper, xxl, height);

    .avatar-content {
      width: map-get($j-avatar-size, avatar, xxl, width);
      height: map-get($j-avatar-size, avatar, xxl, height);

      :deep(img) {
        width: 100%;
        height: 100%;
      }
    }
  }

  &.xl-3 {
    width: map-get($j-avatar-size, wrapper, xl-3, width);
    height: map-get($j-avatar-size, wrapper, xl-3, height);

    .avatar-content {
      width: map-get($j-avatar-size, avatar, xl-3, width);
      height: map-get($j-avatar-size, avatar, xl-3, height);

      :deep(img) {
        width: 100%;
        height: 100%;
      }
    }
  }

  &.full {
    .avatar-content {
      width: 100%;

      :deep(img) {
        width: 100%;
        height: 100%;
      }
    }
  }
}

.j-avatar-status {
  display: flex;
  justify-content: center;
  align-items: center;
  position: absolute;
  right: 0;
  bottom: 0;
  width: 14px;
  height: 14px;
  border-radius: 100%;
  background-color: #fff;

  &.xs {
    right: -2px;
    bottom: -2px;
  }
}
</style>
